/*
 
 Copyright (C) 2010 Timo Lassmann <timolassmann@gmail.com>
 
 This file is part of SAMstat.
 
 Delve is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 Delve is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with Delve.  If not, see <http://www.gnu.org/licenses/>.
 
 */

struct read_info{
	unsigned char* name;
	unsigned char* qual;
	unsigned char* seq; 
	unsigned int* flag;
	unsigned int* hits;
	unsigned char* cigar;
	unsigned char* md;
	unsigned char* RNAME;
	unsigned char* POS;
	unsigned char* MRNM;
	unsigned char* MPOS;
	unsigned char* ISIZE;
	unsigned char* remain;
	
	float mapq;
	float* priors;
	float* identity;
	int len;
	int errors;
	int a;
};



struct fasta{
	unsigned char** sn;
	unsigned char* string;
	int* mer_hash;
	int* boost;
	int* s_index;
	int* suffix;
	int numseq;
	int max_len;
	int string_len;
};


void print_seq(struct read_info* ri,FILE* out);
void print_sam(struct read_info* ri,FILE* out,int good);
int read_sam_chunk(struct read_info** ri,struct parameters* param,FILE* file);
int read_fasta_fastq(struct read_info** ri,struct parameters* param,FILE *file);

void unaligned_to_sam(struct read_info* ri,FILE* out);

struct fasta* read_fasta(struct fasta* aln);
struct fasta* get_fasta(struct fasta* p,char *infile,int solid,int server);
unsigned char* get_input_into_string(unsigned char* string,char* infile,int server);



void free_aln(struct fasta*aln);

