/*
 
Contains code from Numerical recipes in C
 
 */

#include <emmintrin.h>
#include <mmintrin.h>

#ifdef __GNUC__
#define _MM_ALIGN16 __attribute__ ((aligned (16)))
#endif
#define PI 3.14159265
#define MAXIT 100 
#define EPS 3.0e-7 
#define FPMIN 1.0e-30

unsigned char* reverse_complement2(unsigned char* p,int len);
unsigned char* reverse_without_complement(unsigned char* p,int len);

double binomial_distribution(double p , int n, int k);
double gammln(const double xx);
float betai(float a, float b, float x);
float betacf(float a, float b, float x);

int cmpr(const void *a, const void *b);

char* shorten_pathname(char* p);
int byg_end(const char* pattern,const char*text);


int bpm(const unsigned char* t,const unsigned char* p,int n,int m,int limit);


int validate_bpm_sse(unsigned char**  query, int* query_lengths,unsigned char* t,int n,int num);

